/* config.h.  Generated automatically by configure.  */
/* $Id: config.h.in,v 3.1 1997/05/13 05:34:26 darren Exp $   */
/*----------------------------------------------------------------------------
 *  User customization section
 *--------------------------------------------------------------------------*/

/*  Define this label if the const keyword is not supported (or is improperly
 *  implemented) by your compiler.
 */
/* #undef const */

/*  Define this label if you have <stdlib.h>.
 */
#define HAVE_STDLIB_H 1

/*  Define this label if you have <unistd.h>.
 */
#define HAVE_UNISTD_H 1

/*  Define this label if <limits.h> causes PATH_MAX to be defined.
 */
#define INCLUDE_LIMITS_H 1

/*  Define this label if <limits.h> does not define PATH_MAX, but <dirent.h>
 *  causes MAXNAMLEN to be defined.
 */
/* #undef INCLUDE_DIRENT_H */

/*  Define this label to use the system sort utility (which is probably more
 *  efficient) over the interal sorting algorithm.
 */
#define EXTERNAL_SORT 1

/*  If you are using the system sort utility (i.e. external sort), define
 *  this label to be the name of your awk program, which is used to report
 *  duplicate tags when the -W option is specified.
 */
#define AWK "mawk"

/*  If you do not have the library call remove(), define this label
 */
/* #undef REMOVE_MISSING */

/*  If you receive error or warning messages indicating that you are missing
 *  a prototype for, or a type mismatch using, one of the following functions,
 *  define the appropriate label and remake.
 */
/* #undef NEED_PROTO_REMOVE */
/* #undef NEED_PROTO_UNLINK */
/* #undef NEED_PROTO_MALLOC */
/* #undef NEED_PROTO_GETENV */
/* #undef NEED_PROTO_STRSTR */
/* #undef NEED_PROTO_STAT */

/*----------------------------------------------------------------------------
 *  You should not need to change anything below this line
 *--------------------------------------------------------------------------*/

/*  This corrects the problem of missing prototypes for certain functions
 *  in some GNU installations (e.g. SunOS 4.1.x).
 */
#if defined(__GNUC__) && defined(__STDC__) && !defined(__USE_FIXED_PROTOTYPES__)
# define __USE_FIXED_PROTOTYPES__
#endif

#include <stdio.h>		/* to define "FILE" and "SEEK_SET" */

#ifndef SEEK_SET
# define SEEK_SET 0
#endif

/*  This defines the replacement for the remove() library call.
 */
#ifdef REMOVE_MISSING
# ifdef HAVE_UNISTD_H
#  include <unistd.h>		/* to declare unlink() */
# endif
# define remove(fname)	unlink(fname)
#endif

/*----------------------------------------------------------------------------
 *  Potentially missing prototypes
 *--------------------------------------------------------------------------*/

/*  Determine whether to use prototypes or simple declarations.
 */
#ifndef __ARGS 
# if defined(__STDC__) || defined(WIN32)
#  define __ARGS(x) x
#  define USING_PROTOTYPES
# else
#  define __ARGS(x) ()
/* #  undef USING_PROTOTYPES */
# endif
#endif

#if defined(NEED_PROTO_REMOVE) && !defined(REMOVE_MISSING) 
extern int remove __ARGS((const char *));
#endif

#if defined(NEED_PROTO_UNLINK) && defined(REMOVE_MISSING)
extern void *unlink __ARGS((const char *));
#endif

#ifdef NEED_PROTO_MALLOC
extern void *malloc __ARGS((size_t));
#endif

#ifdef NEED_PROTO_GETENV
extern char *getenv __ARGS((const char *));
#endif

#ifdef NEED_PROTO_STRSTR
extern char *strstr __ARGS((const char *str, const char *substr));
#endif

#ifdef NEED_PROTO_STAT
# include <sys/types.h>
# include <sys/stat.h>
int stat __ARGS((const char *, struct stat *));
#endif

/* vi:set tabstop=8 shiftwidth=4: */
